package com.telpo.dipperposition.controller;

import com.alibaba.nacos.api.PropertyKeyConst;
import com.alibaba.nacos.api.exception.NacosException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Properties;
import java.util.concurrent.Executor;
import com.alibaba.nacos.api.NacosFactory;
import com.alibaba.nacos.api.config.ConfigService;
import com.alibaba.nacos.api.config.listener.Listener;

/**
 * @program: DipperPositionController
 * @description: 北斗定位
 * @author: linwl
 * @create: 2020-07-10 14:01
 */
@RestController
@Slf4j
public class DipperPositionController {

  @RequestMapping("/getPos")
  public String getPos() throws NacosException, InterruptedException {
      String serverAddr = "localhost";
      String dataId = "dipperposition-service-dev";
      String group = "DEFAULT_GROUP";

      String positionId = "String.hello";
      Properties properties = new Properties();
      properties.put(PropertyKeyConst.SERVER_ADDR, serverAddr);
      ConfigService configService = NacosFactory.createConfigService(properties);
      String content = configService.getConfig(dataId, group, 10000);
      System.out.println(content);
      configService.addListener(dataId, group, new Listener() {
          @Override
          public void receiveConfigInfo(String configInfo) {
              log.info("recieve:" + configInfo);
          }

          @Override
          public Executor getExecutor() {
              return null;
          }
      });

      boolean isPublishOk = configService.publishConfig(dataId, group, "content");
      log.info(String.valueOf(isPublishOk));
      Thread.sleep(3000);

      configService = NacosFactory.createConfigService(properties);
      content = configService.getConfig(dataId, group, 10000);
      log.info(content);

      content = configService.getConfig(positionId, group, 10000);
      log.info(content);

      //boolean isRemoveOk = configService.removeConfig(dataId, group);
      //log.info(String.valueOf(isRemoveOk));
      //Thread.sleep(3000);

      //content = configService.getConfig(dataId, group, 10000);
      //log.info(content);
      //Thread.sleep(30000);

      //System.out.println(content);

      return "Helle world!"; //ContextLoader.getCurrentWebApplicationContext().toString();
  }
}
